#ifndef __AUTOPGHWIDGET_H
#define __AUTOPGHWIDGET_H

#include <boost/shared_ptr.hpp>
#include <QtGui/QFrame>
#include <list>
#include "line.h"
#include "object_instance_list.h"
#include "pgh_2dobject.h"
#include "pgh_scene.h"

class AutoPghWidget: public QFrame
{
  Q_OBJECT
 public:
  AutoPghWidget( QWidget *parent, Qt::WFlags f = 0 );
 protected:
  virtual void timerEvent( QTimerEvent * );
  virtual void paintEvent( QPaintEvent * );
  boost::shared_ptr< mimas::pgh_2dobject > house;
  mimas::pgh_scene camera_scene;
  boost::shared_ptr< std::list< boost::shared_ptr< mimas::line > > > geom;
  boost::shared_ptr< mimas::object_instance_list > houses;
};

#endif
