#ifndef PICTURE_H
#define PICTURE_H

#include <QtGui/QPixmap>
#include <vector>

#include "mimasexception.h"
#include "camera.h"
#include "image_v4linput.h"
#include "rgba.h"

using namespace mimas;
using namespace camera_calibration;
using namespace std;

typedef rgba< unsigned char > pixel_rgba;

class Picture {

 private:
  QPixmap pixmap;
  image< pixel_rgba > img;

 public:
  vector< pixel_f > points;
  pixel_f corns[4];

  Picture(string device) throw (mimasexception);

  QPixmap getPixmap(){ return pixmap; }
  image< pixel_rgba > getImage(){ return img; }

};

#endif
