//
// Filter by colour - brainstorming
// $Header: /cvs/mimas2/examples/colourFilter/main.cc,v 1.1.1.1 2005/08/09 15:37:34 engmb Exp $
//


#include <iostream>
#include <fstream>
#include "image.h"
#include "image_fileinput.h"
#include "image_mesaoutput.h"

using namespace std;
using namespace mimas;



int main(int argc, char **argv)
{
  int retVal = 0;
  try {
    x11_display display;
    image< unsigned char > someimage;
    image< rgba< unsigned char > > img;
    image_mesaoutput< unsigned char > window( &display );
    // int i;

    const char *imagefile="../images/stills/baboon-512x512-colour.ppm";
    ifstream stream( imagefile, ios::binary );
    stream >> img;

    int redRef, greenRef, blueRef, redRange, blueRange, greenRange;

    // First filter
    redRef=250;
    greenRef=63;
    blueRef=15;
    redRange=30;
    greenRange=15;
    blueRange=8;

    someimage.init( img.getWidth(), img.getHeight() );


    for (int j=0; j<img.getHeight(); j++)
      for (int i=0; i<img.getWidth(); i++)
	{
	  int r,g,b;
	  r=img.pixel(i,j).getRed();
	  g=img.pixel(i,j).getGreen();
	  b=img.pixel(i,j).getBlue();

	  if ((abs(r-redRef)<=redRange) && (abs(g-greenRef)<=greenRange) && (abs(b-blueRef)<=blueRange))
	    someimage.setPixel(i,j,0);
	  else
	    someimage.setPixel(i,j,255);
	}

    window << someimage << mimas::pause();
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
