//
// stumeikle
// canny (with postprocessing) example
//


#include <iostream>
#include <fstream>
#include <vector>
#include "image.h"
#include "image_fileinput.h"
#include "image_mesaoutput.h"
#include "image_funcs.h"
#include "property_image.h"
#include "canny_tool.h"
#include "corner_tool.h"

using namespace std;
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
    image<int> input;
    canny_tool<int> canny;
    corner_tool<int> corner;
    corner_image cim;
    property_image pim;
    edge_string_ptr_list edge_strings;
    x11_display display;
    image_mesaoutput< rgba< unsigned char > > window( &display );

    ifstream file( argv[1], ios::binary );
    MMERROR( file >> input, mimasexception, , "Error loading file \""
             << argv[1] << "\"." );

    //extract features
    corner.filterImage(input, cim);
    edge_strings=canny.findEdgeStrings( input );
    // pim.setOwnership(false);
    pim.init( input.getWidth(), input.getHeight());
    pim.addStrings( edge_strings );

    //then create an image to contain them for visualisation
    //be very careful about who owns the data!
    pim+=cim;
    
    displayWithOverlay( window, input, pim ); window << mimas::pause();
    
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}


