//
// Example application using canny
// Bala Amavasai <bala@amavasai.org>
//
// $Header: /cvs/mimas2/examples/corner_tool/main.cc,v 1.1.1.1 2005/08/09 15:37:35 engmb Exp $
//


#include <iostream>
#include <fstream>
#include <vector>
#include "image.h"
#include "image_fileinput.h"
#include "image_funcs.h"
#include "image_mesaoutput.h"
#include "canny.h"
#include "filter.h"
#include "corner_tool.h"
#include "prop.h"

using namespace std;
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
   
    MMERROR( argc == 2, mimasexception, ,
	     "Syntax: " << argv[0] << " <image-file>" );
   
    x11_display display;
    image<int> someimage;
    corner_tool<int> corner_op(0.1);
    image_mesaoutput< rgba< unsigned char > > window( &display );
   
    ifstream file( argv[1], ios::binary );
    MMERROR( file >> someimage, mimasexception, ,
	     "Error loading file \"" << argv[1] << "\"." );

    corner_image cim;
    corner_op.filterImage(someimage, cim);
    displayWithOverlay( window, someimage, cim ); window << mimas::pause();
   
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
