//
// Histogram equalisation example
// Bala Amavasai <bala@amavasai.org>
//
// $Header: /cvs/mimas2/examples/equalise/main.cc,v 1.1.1.1 2005/08/09 15:37:30 engmb Exp $
//

#include <iostream>
#include <fstream>
#include "image.h"
#include "image_fileinput.h"
#include "image_mesaoutput.h"
#include "image_funcs.h"

using namespace std; 
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
    x11_display display;
    image<int> someimage;
    image_mesaoutput< unsigned char > window( &display );

    ifstream file( "../images/stills/lena-512x512.pgm", ios::binary );
    file >> someimage;
    window << someimage << mimas::pause();

    equalise(someimage);
    window << someimage << mimas::pause();
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
