//
// stumeikle
// canny (with postprocessing) example
//

#include <fstream>
#include <GL/glut.h>
#include <iostream>
#include <vector>
#include "image.h"
#include "image_fileinput.h"
#include "image_mesaoutput.h"
#include "rgba.h"
#include "property_image.h"
#include "gauss.h"

using namespace std;
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {

    // Initialise GLUT.
    glutInit( &argc, argv );

    MMERROR( argc == 2, mimasexception, ,
             "Syntax: " << argv[0] << " <image-file>" );

    image< unsigned char > input;
    x11_display display;
    image_mesaoutput< unsigned char > window( &display );

    
    ifstream file( argv[1], ios::binary );
    MMERROR( file >> input, mimasexception, , "Error loading file \""
             << argv[1] << "\"." );

    window << input << mimas::delay( 3000 )
           << image< unsigned char >( gaussBlur< float >
                                      ( input, 10.0f, 4.0f / 256.0f ) )
           << mimas::wait( 3000 );

  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
