//
// Example usage of edge detectors
// Bala Amavasai (bala@amavasai.org)
//
// $Header: /cvs/mimas2/examples/kuwahara/main.cc,v 1.1.1.1 2005/08/09 15:37:34 engmb Exp $
//
#include <iostream>
#include <fstream>
#include "image.h"
#include "image_fileinput.h"
#include "image_op.h"
#include "image_mesaoutput.h"
#include "canny.h"
#include "image_funcs.h"

using namespace std;
using namespace mimas;

int	main(int argc, char **argv)
{
  int retVal = 0;
  try {
   x11_display display;
   image<int> imagein, imageout, tmp;
   canny<int> canny;
   image_mesaoutput< unsigned char > window( &display );

   // set up Canny parameters
   canny.setCannyAutoThres(false);
   canny.setCannyStdDev(1.6);

   ifstream file( argv[1], ios::binary );
   file >> imagein;

   window << imagein << mimas::pause();

   tmp = imagein;

   // run Canny on input image
   canny.getEdges(tmp);
   window << ( 255 - tmp ) << mimas::pause();

   // run Kuwahara twice on input image
   despeckleKuwahara(imagein,imageout);
   imagein = imageout;
   despeckleKuwahara(imagein,imageout);
   window << imageout << mimas::pause();

   // run Canny on Kuwahara image
   canny.getEdges(imageout);
   window << ( 255 - imageout ) << mimas::pause();

  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}


