//!! Make it generic for any kind of hypothesis 

template<typename Hypothesis_T>
void compensate_speed<Hypothesis_T>::outweigh(Hypothesis_T &s)
{
  //just taking into account the speed (without direction) 
  float add = 0;

  if(previous_location_instanciated && probable_location_instanciated)
    {
      Point diff(2);     
      diff(0) = probable_location(0) - s.x;
      diff(1) = probable_location(1) - s.y;

      velocity(0) = probable_location(0) - previous_location(0); 
      velocity(1) = probable_location(1) - previous_location(1); 
          
      float dist = boost::numeric::ublas::norm_2(diff);
      float speed = boost::numeric::ublas::norm_2(velocity);

      if(speed != 0){
	add = 1 - (abs_val(dist-speed) / (FACTOR * speed));
      }
      
      add *= TO_DETERMINE;

      if (add < 0)
	add = 0;
      // We don't have to take into account the speed for the first frame      
    }
  
  s.weight += add; 
}
