#ifndef MMVL_OBSERVER_3D_H_INCLUDED
#define MMVL_OBSERVER_3D_H_INCLUDED

#include <iostream>
#include <string>
#include <vector>

#include <hypothesis3D.h>
#include <image.h>
#include "mapping.h"

namespace mimas{
  namespace hf{  

/**********************************************************************
 *This class can be looked at to see what it is necessary to implement for 
 *an observer policy. The implementation is not complete in the sense
 *that the observe function don't make measure on the image.
 *However it will draw in white on the image the aspect of the hypothesied 
 *location of the rubik's cube.
 * 
 * @author: Manuel Boissenin
 * @date: june 2003
 *
 * Time-stamp: <2005-05-04 16:21:56 engmb>
 * Copyright (C) 2004 by Manuel Boissenin
 *
 ***********************************************************************/
    template<typename Hypothesis_T, typename Pixel_T>
      class observer3D
      {
      private:
	image<Pixel_T> &image_private; ///<reference to the observed image

      public:

	parallelepiped cuboid;
	mapper mapper_;
	Point trans;
	vec rot;

	class set{
	};
	
	observer3D(image<Pixel_T> &image, set nothing_at_the_moment):
	  image_private(image), cuboid(57,57,57),mapper_(815.63, 819.59, 342.19, 268.47, 0.05454, 0.1023,0.0034, 0.00217),
	       trans(3),rot(3)//parametres of the camera. Values for the rubik's sequence
	  {
	    cerr<<"Observer constructor ......."<<endl;
	    mapper_.add_figure(cuboid);
	  }

	//No observation is done at the moment 
	void observe(hypothesis3D &p);

        void draw(const hypothesis3D &h)
	{
	  trans(0) = h.x;
	  trans(1) = h.y;
	  trans(2) = h.z;
	  rot(0) = h.Rx;
	  rot(1) = h.Ry;
	  rot(2) = h.Rz;
	  
	  cuboid.rotate(rot);
	  cuboid.translate(trans);

	  mapper_.getPoints(30);
	  mapper_.mapPoints();
	  mapper_.plot(image_private, Pixel_T(255,0,0));
	}	
      };

#include "observer3D.tcc"
  }
} 
#endif
