#include <fstream>
#include <iostream>
#include <cstdlib>
#include "image.h"
#include "image_fileinput.h"
#include "image_funcs.h"
#include "image_mesaoutput.h"

using namespace std; 
using namespace mimas;

int	main(int argc, char **argv)
{
  int retVal = 0;
  try {
	x11_display display;
	image_mesaoutput< unsigned char > window( &display );
	
 	MMERROR( argc == 3, mimasexception, ,
            "Syntax : " << argv[0] << " pgm-input-image threshold" );
	
	image< unsigned char > in_image;
	ifstream infile( argv[1], ios::binary );
	MMERROR( infile >> in_image, mimasexception, ,
            "Error loading image \"" << argv[1] << "\"." );

   unsigned char thresh = (unsigned char)atoi(argv[2]);

   window << in_image << mimas::delay( 3000 )
	  << bilevel( in_image, thresh,
		      (unsigned char)0, (unsigned char)255 )
	  << mimas::pause();
   
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
