#ifndef __WEBCAMTRACKWIDGET_H
#define __WEBCAMTRACKWIDGET_H

#include <boost/shared_ptr.hpp>
#include <QtGui/QFrame>
#include "cartesian.h"
#include "image_v4linput.h"
#include "segment_hashmap_tool.h"

class WebcamTrackWidget: public QFrame
{
  Q_OBJECT
 public:
  WebcamTrackWidget( QWidget *parent, Qt::WFlags f = 0 );
 protected:
  virtual void timerEvent( QTimerEvent * );
  virtual void paintEvent( QPaintEvent * );
  void findEnclosedArea( int x, int y,
                         mimas::image< mimas::rgba< unsigned char > > &refimg,
                         int threshold, mimas::Cartesian<int> &min,
                         mimas::Cartesian<int> &max, int &areacount );
#ifdef HAVE_LINUX_VIDEODEV_H
  mimas::image_v4linput< mimas::rgba< unsigned char > > webcam;
#endif
  mimas::segment_hashmap_tool hashmap;
  mimas::image< mimas::rgba< unsigned char > > im;
  int counter;
};

#endif
