template <typename Hypothesis_T, typename Pixel_T>
std::vector<Hypothesis_T> analyse_result_blob<Hypothesis_T, Pixel_T>::analyse(void)
{
  peaks.clear();
  blobs.clear();
  
  typename std::vector<Hypothesis_T>::iterator it_h;
  typename std::vector<std::vector<Hypothesis_T> >::iterator it_p;

  //Threshold the hypothesis and create different set
  //of hypothesis that will be around the same peak.
  for(it_h = hypotheses_AR.begin(); it_h != hypotheses_AR.end(); it_h++)
    {
      //std::cerr<<"Weight is:"<< it_h->weight<<std::endl;
      if(it_h->weight > weight_threshold)
	{
	  bool joined = false;	  
	  for(it_p = peaks.begin(); it_p != peaks.end(); it_p++)
	    if ((*it_h).distance((*it_p).front()) < peak_distance)
	      {
		(*it_p).push_back(*it_h);
		joined = true;
		std::cerr<<"one blob merged"<<std::endl;
	      }	      
	  
	  
	  if(!joined)
	    {
	      std::vector<Hypothesis_T> newSet;
	      newSet.push_back(*it_h);
	      peaks.push_back(newSet);
	      std::cerr<<"one blob added"<<std::endl;
	    }
	}
    }

  //Add to the peak set the rest of the hypothesis
  for(it_h = hypotheses_AR.begin(); it_h != hypotheses_AR.end(); it_h++)
    {
      if(it_h->weight < weight_threshold)
        for(it_p = peaks.begin(); it_p != peaks.end(); it_p++)
	  {
	    if ((*it_h).distance((*it_p).front()) < merge_distance)
	      {
		(*it_p).push_back(*it_h);
	      }	      
	  }      
    }

  //do the mean for each peak set
  for(it_p = peaks.begin(); it_p != peaks.end(); it_p++)
    {
      Hypothesis_T blob;
      blob.weight = 0;
      std::cerr<<"Number of hypotheses taken into account with this peak: "<<  (*it_p).size() << std::endl;
      
      for(it_h = (*it_p).begin(); it_h != (*it_p).end(); it_h++)
	{
	  blob = blob.mean(*it_h);
	}
      std::cerr<<"one blob should appear"<<std::endl;
      blobs.push_back(blob);
    }

  
  //a bit of statistics
  int hypothesis_with_null_value = 0;
  int hypothesis_with_value1 = 0;
  int hypothesis_with_value2 = 0;
  int hypothesis_with_value3 = 0;
  int hypothesis_with_value4 = 0;
  int hypothesis_with_value5 = 0;
  int hypothesis_with_value6 = 0;
  int hypothesis_with_value7 = 0;
  int hypothesis_with_value8 = 0;


  for(it_h = hypotheses_AR.begin(); it_h != hypotheses_AR.end(); it_h++)
    {
      if(it_h->weight == 0)
	hypothesis_with_null_value ++;
      else if (it_h->weight < .1)
	hypothesis_with_value1 ++;
      else if (it_h->weight < .3)
	hypothesis_with_value2 ++;
      else if (it_h->weight < .5)
	hypothesis_with_value3 ++;
      else if (it_h->weight < .7)
	hypothesis_with_value4 ++;
      else if (it_h->weight < .8)
	hypothesis_with_value5 ++;
      else if (it_h->weight < .9)
	hypothesis_with_value6 ++;
      else if (it_h->weight < 1)
	hypothesis_with_value7 ++;
      else
	hypothesis_with_value8 ++;
    }
  
  std::cerr<< "A bit of statistics :"<<std::endl;
  std::cerr<< "Number of hypothesis with weight 0, below .1, below .3 "<<std::endl
	   << "below .5 below .7 below .8 below .9 below 1 and above 1"<<std::endl;
  std::cerr<<hypothesis_with_null_value << std::endl;
  std::cerr<<hypothesis_with_value1 << std::endl;
  std::cerr<<hypothesis_with_value2 << std::endl;
  std::cerr<<hypothesis_with_value3 << std::endl;
  std::cerr<<hypothesis_with_value4 << std::endl;
  std::cerr<<hypothesis_with_value5 << std::endl;
  std::cerr<<hypothesis_with_value6 << std::endl;
  std::cerr<<hypothesis_with_value7 << std::endl;
  std::cerr<<hypothesis_with_value8 << std::endl;
  
  std::cerr<<"Out of"<< hypotheses_AR.size() << "hypotheses" << std::endl;
  
  return blobs;
}


