// stuart meikle
//


#ifndef COORDINATE_XFORM_H
#define COORDINATE_XFORM_H

#include <boost/numeric/ublas/vector.hpp>
#include <boost/smart_ptr.hpp>
#include "angle.h"

namespace mimas {
/* A means to realte an obhject to another object's coordinate system.
   Sometimes arbitrary objects need to be rotated and orientated and have
   their default co-ordinate system changed. This is the class to do it with,
   but at the moment its very simple. I imagine in the future that a tensor
   matrix or co-variance mbatrix be used, and ideally the object to be
   operated on shouldn't be fixed. I use it now with the pgh models.
   @author Stuart Meikle (stu@stumeikle.org)
   @date Fri Jul  7 10:53:00 2000 */
class	coordinate_xform 
{
    //WARNING! : this will become considerably more complex in the future!!
    //we should really use a covariance matrix here. stu. 
 public:
  typedef boost::numeric::ublas::vector< double > Vector;
    private:
	Vector displacement;
	angle	rotation;
    
    public:
	void	setDisplacement( const Vector &v )
		{ displacement = v; }
	const Vector &getDisplacement(void) const
		{ return displacement; }
	void	setRotation( angle a )
		{ rotation = a; }
	angle	getRotation( void )
		{ return rotation; }
    
};

typedef boost::shared_ptr< coordinate_xform > coordinate_xform_ptr;
typedef std::list< coordinate_xform_ptr > coordinate_xform_ptr_list;

};

#endif

