#ifndef DICE_H
#define DICE_H

#include <cmath>
#include <cstdlib>

/**@ingroup pf
@brief random routines.

Generate a number between 0 and 1 with uniform_random(). 
Generate a gaussian_random() number (mean 0 sigma 1).

*/
//namespace ?

class Dice{
public:
/* This is the worst random number routine in the known universe, but
   I use it for portability. Feel free to replace it. */
static double uniform_random(void)
{
  return (double) rand() / (double) RAND_MAX;
}

/* This Gaussian routine has been taken from Numerical Recipes and is their
   copyright --> to be fixed ?!!!?. */

  static double gaussian_random(void)
  {
    static int next_gaussian = 0;
    static double saved_gaussian_value;

    double fac, rsq, v1, v2;

    if (next_gaussian == 0) {
      do {
	v1 = 2.0*uniform_random()-1.0;
	v2 = 2.0*uniform_random()-1.0;
	rsq = v1*v1+v2*v2;
      } while (rsq >= 1.0 || rsq == 0.0);
      fac = sqrt(-2.0*log(rsq)/rsq);
      saved_gaussian_value=v1*fac;
      next_gaussian=1;
      return v2*fac;
    } else {
      next_gaussian=0;
      return saved_gaussian_value;
    }
  }
};

 
#endif
