//
// edge string operations
// a filter for edgels
// stumeikle Mon May  6 17:46:01 2002
//
// choosing to make this functionality as an operator for
// property images. don't want to bind it to edge_image
// because we could have mixed property images in the future
// also in theory edge strings could be derived from other
// input sources.
//
// $Header: /cvs/mimas2/include/edge_string.h,v 1.1.1.1 2005/08/09 15:37:45 engmb Exp $
//


#ifndef EDGE_STRING_H
#define EDGE_STRING_H

#include "string_el.h"

namespace mimas {

/** Set of edge-points.
    An edge string is a set of edge points that are contiguous on the image
    plane. \c canny_tool::findEdgeStrings returns a set of strings rather than
    an image with edge points. So for example if you have a black square on a
    white background and you extract the edges, you will probably receive 1
    edge string back which will be a linked list of all the edges going around
    the square. */
typedef string_el_ptr_list edge_string;
///
typedef boost::shared_ptr< edge_string > edge_string_ptr;
///
typedef std::list< edge_string_ptr > edge_string_ptr_list;

}

#endif
