#ifndef IMAGE_OP_H
#define IMAGE_OP_H

/** @addtogroup arrayOp
    @{ */
/** @page imageOperators Operators for mimas::image.
    Element-wise operations for 2-dimensional images are implemented using the
    @ref arrayOperators "operators for boost::multiarray".

    Functionality, which is specifically related to two-dimensional images,
    is implemented for \c mimas::image.

    Algorithms, which can also be applied to n-dimensional arrays, are
    implemented for \c boost::multi_array. Corresponding wrappers for
    forwarding the calls are implemented for \c mimas::image.

    @author Jan Wedekind <jan@wedesoft.de> 
    @date Mon Jun 13 17:19:18 UTC 2005
    @todo Add documentation of all available image-operators. */
///@}
#include "image.h"
#include "image_op.tcc"

#endif
