#ifndef __MULTI_ARRAY_OP_H
#define __MULTI_ARRAY_OP_H

/** @defgroup arrayOp Array operators
    Mimas has support for doing element-wise operations and convolutions on
    \c boost::multi_array as well as mimas::image.
    @author Jan Wedekind <jan@wedesoft.de> 
    @date Mon Jun 13 17:13:05 UTC 2005
    @{ */
/** @page arrayOperators Operators for boost::multi_array.
    Implementations for element-wise operations on multi-dimensional arrays
    are provided. \c boost::multi_array is used to represent the
    multidimensional arrays.

    The supported operations are:
    \li Associative array-scalar operators: multiplication, plus and minus.
    \li Non-associative array-scalar operators: division, threshold.
    \li Array-array operators: multiplication, division, plus and minus.

    The following example demonstrates, how versatile the array-operators
    provided by mimas are:
    \include arrayop/main.cc

    @author Jan Wedekind <jan@wedesoft.de> 
    @date Mon Jun 13 17:13:05 UTC 2005
    @todo Does not compile under Solaris at the moment.
    @todo Add documentation of all available array operators. */
#include "multi_array_op.tcc"
///@}

#endif
