#ifndef OPTICFLOW_DIFF_TOOL_H
#define OPTICFLOW_DIFF_TOOL_H

#include "mimasconfig.h"
#include "image_funcs.h"
#include "image.h"
#include "filter_grad.h"

#ifdef HAVE_LIBLAPACK

namespace mimas {
/**
 * Differential optic flow - see page 196-197 of Trucco and Verri
 * @author Bala Amavasai (bala@amavasai.org)
 * @date Mon Aug  5 11:54:14 UTC 2002
 * $Header: /cvs/mimas2/include/opticflow_diff_tool.h,v 1.1.1.1 2005/08/09 15:37:45 engmb Exp $
 */
class opticflow_diff_tool
{

	private:
		int windowdist;
		image<double> xflow,yflow;
		void smoothGaussian(image<double>& imagein, double variance);
		double variance;

	public:
		opticflow_diff_tool(void); ///< constructor
		~opticflow_diff_tool(void); ///< destructor
		void findFlow(image<int> &image_t, image<int> &image_dt); ///< find the optic flow using input images taken at time t and at t+dt
		void findFlow(image<double> &image_t, image<double> &image_dt);
		void findFlow( std::vector< image<double> > &imagein); ///< find the optic flow using input images taken at time t and at t+dt
		void getXflow(image<double>& xf); ///< get the x direction vector flow
		void getYflow(image<double>& yf); ///< get the y direction vector flow

};

}

#endif

#endif
