#ifndef POL_LOCATOR_SCALE_H
#define POL_LOCATOR_SCALE_H

#include "mimasconfig.h"

#include <boost/numeric/ublas/vector.hpp>
#include <list>
#include "pol_locator_hough.h"

namespace mimas {
/**
 *
 * adding scale invariant recognition capabilities
 * to the POL stuff.
 *
 * (again)
 * stumeikle 20030228
 *
 */
class pol_scale_info
{
public:
   typedef boost::numeric::ublas::vector< double > Vector;
	float	weight;
	float	scale;

   pol_scale_info()
   { scale=weight=0; }
   pol_scale_info(int i)
   { scale=(float)i; weight=0; }

    operator	int()
    {
	return (int)(scale/weight);
    }

};

class pol_locator_scale : public pol_locator_hough
{
    /**
     * just overload the add entry function
     */


private:
 	    image<pol_scale_info>	 scale_im;
	    				 /**not required for recognition! but gives a scale
					  * result to the user. HOW MUCH MEMORY DO WE NEED?!?!
					  */

public:

    /**
     * constructor. pass on a threshold value. this is a total
     * hack. someone should work out how the threshold value changes
     * with the model and how it varies when we need scale invariance.
     *
     */
    pol_locator_scale(double d) : pol_locator_hough(d*8.0) //use 8 for +-50%
    								  //use 2 for +- 5%
    {}

            void		addEntry( double weight, ... );
	    void		init(int numdims,...);
       pol_match_ptr_list getMatches();

};

}

#endif

