#ifndef POL_SCENE_H
#define POL_SCENE_H


#include "mimasconfig.h"

#include <boost/shared_ptr.hpp>
#include "image.h"
#include "pol_locator.h"
#include "pol_model.h"

namespace mimas {
/**
 * Pairs of lines scene
 *
 * for now, organised as being distinct from the model class.
 * search for models in the scene.
 *
 *
 *
 * stumeikle Sun 27 Oct 2002 23:52:15 CET
 * $Header: /cvs/mimas2/include/pol_scene.h,v 1.1.1.1 2005/08/09 15:37:45 engmb Exp $
 *
 */
class pol_scene : public pol
{
private:
//    image<int>		scene;
			        // maybe
    int				im_width,im_height;///< width and height of the image
      pol_line_info_ptr_list	scene_line_info;   ///< the scene 'model' in pairs of lines

    void			makeEntries( pol_model& m,pol_locator& locate);


public:
    pol_scene()
    {
	im_width=im_height=0;
    }
//     ~pol_scene()
//     {
// 	pol_line_info_ptr_list::iterator	i;
// 	for(i=scene_line_info.begin(); i!=scene_line_info.end(); ++i)
// 	{
// 	    delete (*i);
// 	}

// 	scene_line_info.clear();
//     }

    /**
    * create the scene representation from the image file given
    */
    void		createFromImageFile( const char *fn );
    /**
    * create the scene rep from the image given
    */
    void		createFromImage( image<int> & im );
    /**
    * create the scene rep from the set of straight lines given
    */
    void 	createFromLines( line_ptr_list &scene_lines, int , int );
    /**
    *
    * Find the given model in the scene and return a list of matches
    */
    pol_match_ptr_list getMatches( pol_model& m );

    pol_match_ptr_list fastFind( pol_model& m,image<int>& im);
};

}
#endif

