//
// class image_prop
// stumeikle Sun May 12 20:43:47 2002
//
//

#ifndef IMAGE_PROP_H
#define IMAGE_PROP_H

#include <boost/shared_ptr.hpp>
#include "image.h"
#include "rgba.h"
#include "object.h"

namespace mimas {
/**
 *
 * An property_image is an image where every pixel is an prop. this is the 
 * base class for those structures. contains type and draw interface.
 *
 * @author Stuart Meikle (stu@stumeikle.org)
 * @date Sun May 12 20:43:47 2002
 * $Header: /cvs/mimas2/include/prop.h,v 1.1.1.1 2005/08/09 15:37:45 engmb Exp $
 */
class prop: public object
{
    //baseclass of the image properties
    // a property associated with a point on an image
    public:
	typedef enum{undefined_t, edgel_t, corner_t, edge_string_t} property_type;

    private:
	property_type	type;	 ///< value indicating the property type.
	prop		*next; 	 ///< pointer to another property. we could have many props associated with each pixel

    protected:
	void	setPropertyType( property_type t ) { type = t; }

    public:
	prop( property_type t ) { type = t; next=NULL; }

	virtual void draw( image< rgba< unsigned char > >& output,
                      int i, int j, bool c )
	{
	    // draw the property. this should always be overloaded. one time which is
	    // maybe isnt is during canny post processing:
     std::cout << "#FIX ME# PruneJuncs bug at pixel:" << i << "," << j
               << std::endl;
	}
};

typedef boost::shared_ptr< prop > prop_ptr;

}
#endif
